#ifndef __BULKBUFFER_H__
#define __BULKBUFFER_H__

#include <string.h>
#include <vector>

#include "BulkBufferBlock.h"

#define BB (BulkBuffer::instance())
#define BB_reqsize(x)   (x+1)

#define BULKBUFFERBLOCK_SIZE    4096*2
//#define BULKBUFFERBLOCK_SIZE    100

using namespace std;

class BulkBuffer
{
public:
    static BulkBuffer &instance();
    static BulkBuffer *instancePtr();
    void flush();
    bool set(const char *ori, char **dest, const unsigned int size);
    bool set(const char *ori, char **dest);
    bool space(char **dest, const unsigned int size);
    unsigned int  blocks();


    vector<BulkBufferBlock *> buffer;

    unsigned int data_counter, physical_counter;

private:

    static BulkBuffer *inst;
    bool ret;

    BulkBuffer();
    ~BulkBuffer();
    bool add(const unsigned int size);
    bool add();
	bool setData(unsigned int idx, const char *ori, char **dest, const unsigned int size);
    bool setSpace(unsigned int idx, char **dest, const unsigned int size);
};

#endif // __BULKBUFFER_H__
