#ifndef __BULKBUFFERBLOCK_H__
#define __BULKBUFFERBLOCK_H__

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "JbmCommon.h"

class BulkBufferBlock
{
private:
public:
    char *buf, *cur;
    unsigned int sz, sp;

    BulkBufferBlock(unsigned int size)
    {
        alloc(size);
    }

    ~BulkBufferBlock()
    {
        release();
    }

    bool alloc(unsigned int size)
    {
        buf = cur = (char *)malloc(size);
        sz = size;
        sp = size;
        flush();
        return true;
    }

    bool release()
    {
        if(buf != NULL) free(buf);
        return true;
    }

    void flush()
    {
		cur = buf;
        sp  = sz;
        memset(buf, 0x00, sz);
    }

    bool set(const char *ori, char **dest)
    {
        return set(ori, dest, strlen(ori));
    }

    bool set(const char *ori, char **dest, const unsigned int size)
    {
        if(sp < size+1) return false;
        *dest = (char *)memcpy(cur, ori, size);
        cur    += (size+1);
        sp     -= (size+1);
        return true;
    }

    bool space(char **dest, const unsigned int size)
    {
        if(sp < size) return false;
        *dest = cur;
        cur    += (size);
        sp     -= (size);
        return true;
    }
};

#endif // __BULKBUFFERBLOCK_H__
