#ifndef __JBMMYSQL_H__
#define __JBMMYSQL_H__

#include <string>
#include <mysql/mysql.h>

#include "JbmDataset.h"
#include "BulkBuffer.h"

using namespace std;

class JbmMysql
{
private:

    MYSQL   _con, *_pcon;

    char    *_host, *_user, *_pass, *_dbname;
    int     _port, _affected_rows;

public:
    JbmMysql(const char *host,
            const char *user,
            const char *pass,
            const char *dbname,
            const int port = 3306);

    ~JbmMysql();

    bool            connect();

    const char      *error();
    int             errno();

    JbmResult       getRows(const char *query); // throw(const char *error_messag)
    JbmRow          getRow(const char *query);  // throw(const char *error_messag)
    const char      *getOne(const char *query); // throw(const char *error_messag)
    bool            query(const char *query);   // throw(const char *error_messag)
    int             affected_rows();
};

#endif //__JBMMYSQL_H__
